<template>
  <JButton
    v-if="isShowNewMessagesInfo"
    size="xxs"
    type="stroked"
    class="new-messages-info"
    @click="$emit('click')"
  >
    <JText
      type="text-3"
      weight="normal"
      tag="div"
      class="message-info"
    >
      <JIcon
        icon="longDownArrow"
      />
      <span class="label">{{ $t('new_messages') }}</span>
    </JText>
  </JButton>
</template>

<script setup lang="ts">
import { computed, PropType, toRef } from 'vue';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { JButton, JIcon, JText } from '@new-jira-clone/ui/src/components';
import { IChat } from '@/shared';
import { useConversationDetailsService } from '../model/useConversationDetailsService';

defineEmits<{
  (event: 'click'): void;
}>();

const props = defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
});

const { getUser } = useUserStore();
const { getChatDetails } = useConversationDetailsService();

const chatDetails = toRef(() => getChatDetails(props.chat.id));

const isScrollAtBottom = computed(() => chatDetails.value?.isScrollAtBottom);

const isShowNewMessagesInfo = computed(() => {
  if (props.chat === null) return false;

  const messages = props.chat.messages?.items ?? [];
  const messagesLength = messages.length;
  const lastRead = props.chat.lastRead;

  if (isScrollAtBottom.value) {
    return false;
  }

  for (let index = messagesLength - 1; index >= 0; index -= 1) {
    if (new Date(messages[index].createdAt ?? '0') <= new Date(lastRead ?? '0')) break;
    if (messages[index].author.id !== getUser?.id) {
      return true;
    }
  }

  return false;
});
</script>

<style scoped lang="scss">
.new-messages-info {
  align-items: center;
  position: absolute;
  z-index: 1;
  top: -55px;
  right: 38px;
}

.message-info {
  display: flex;
}

.label {
  margin-left: 6px;
}
</style>
